//
//  AccessibleTableViewCell.m
//  pwSafe
//
//  Created by Jorge P. Vasquez on 24/12/13.
//
//

#import "AccessibleTableViewCell.h"

@implementation AccessibleTableViewCell

- (void)accessibilityIncrement
{
  id<AccessibleTableViewCellDelegate> delegate = _delegate;
  if([delegate respondsToSelector:@selector(accessibleCellIncrement:)])
    [delegate accessibleCellIncrement:self];
}

- (void)accessibilityDecrement
{
  id<AccessibleTableViewCellDelegate> delegate = _delegate;
  if([delegate respondsToSelector:@selector(accessibleCellDecrement:)])
    [delegate accessibleCellDecrement:self];
}

- (NSString *)accessibilityValue
{
  id<AccessibleTableViewCellDelegate> delegate = _delegate;
  if([delegate respondsToSelector:@selector(accessibleCellValue:)])
    return [delegate accessibleCellValue:self];
  else
    return nil;
}

@end
