//
//  AddHelpTextUITableViewController.m
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 6/23/11.
//  Copyright 2011 app77. All rights reserved.
//

#import "AddHelpTextUITableViewController.h"


@implementation UITableViewController (AddHelpTextUITableViewController)

#define HELP_ARROW_TAG 501
#define HELP_TEXT_TAG  502

- (void)adjustFramesArrow:(UIImageView *)arrowView text:(UILabel *)textView parent:(UIView *)helpParentView
{
  CGSize helpParentSize = helpParentView.frame.size;
  arrowView.frame = CGRectMake(helpParentSize.width - 130, helpParentSize.height - 100, 102, 48);
  textView.frame = CGRectMake(helpParentSize.width - 265, helpParentSize.height - 165, 255, 100);
}

- (void) adjustAddHelpText:(NSString *)helpText viewTagBase:(NSInteger)tagBase show:(BOOL)show
{
  if(![self isViewLoaded])
    return;
  UIView *helpParentView = self.parentViewController.view;
  if(!helpParentView)
    return;
  
  UIImageView *arrowView = (UIImageView *)[helpParentView viewWithTag:HELP_ARROW_TAG + tagBase];
  UILabel *textView;
  BOOL exist = !!arrowView;
  if(exist)
  {
    textView = (UILabel *)[helpParentView viewWithTag:HELP_TEXT_TAG + tagBase];
    NSAssert(textView, @"Both should go together");
  }
  else
  {
    NSAssert(!(UILabel *)[helpParentView viewWithTag:HELP_TEXT_TAG + tagBase], @"Both should go together");    
  }
  
  if(show)
  {
    if(!exist)
    {
      arrowView = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"Arrow.png"]];
      arrowView.tag = HELP_ARROW_TAG + tagBase;
      arrowView.alpha = 0;
      
      textView = [[UILabel alloc]init];
      textView.text = helpText;
      textView.tag = HELP_TEXT_TAG + tagBase;
      textView.font = [UIFont fontWithName:@"Marker Felt" size:30];
      textView.lineBreakMode = UILineBreakModeWordWrap;
      textView.numberOfLines = 0;
      textView.backgroundColor = [UIColor clearColor];
      textView.opaque = NO;
      textView.textColor = [UIColor colorWithWhite:.3176 alpha:1];
      textView.alpha = 0;

      [helpParentView addSubview:arrowView];
      [helpParentView addSubview:textView];
      
      [UIView animateWithDuration:.5 
                       animations:^(void) 
      {
         arrowView.alpha = 1;
         textView.alpha = 1;
      }];
    }
    
    [self adjustFramesArrow:arrowView text:textView parent:helpParentView];
  }
  else
  {
    if(exist)
    {
      [UIView animateWithDuration:.5 
                       animations:^(void) 
       {
         arrowView.alpha = 0;
         textView.alpha = 0;
       } 
                       completion:^(BOOL finished) 
       {
         [arrowView removeFromSuperview];
         [textView removeFromSuperview];
       }];
    }
  }
}

- (void)adjustHelpFramesViewTagBase:(NSInteger)tagBase
{
  if(![self isViewLoaded])
    return;
  UIView *helpParentView = self.parentViewController.view;
  if(!helpParentView)
    return;

  UIImageView *arrowView = (UIImageView *)[helpParentView viewWithTag:HELP_ARROW_TAG + tagBase];
  UILabel *textView = (UILabel *)[helpParentView viewWithTag:HELP_TEXT_TAG + tagBase];
  NSAssert(!!textView == !!arrowView, @"Both should go togheter");
  BOOL exist = !!arrowView;

  if(exist)
    [self adjustFramesArrow:arrowView text:textView parent:helpParentView];
}

@end
