//
//  DetailViewController.m
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 6/9/11.
//  Copyright 2011 app77. All rights reserved.
//

#import "DetailViewController.h"
#import "GroupViewController.h"
#import "EntryDetailsViewController.h"

@interface DetailViewController ()

- (id)internalInitWithState:(NSMutableDictionary *)state;

@end

@implementation DetailViewController

+ (DetailViewController *)sharedDetailViewControllerWithState:(NSMutableDictionary *)state
{
  static DetailViewController *obj = nil;
  if(!obj)
    obj = [[DetailViewController alloc]internalInitWithState:state];
  return obj;
}

- (id)internalInitWithState:(NSMutableDictionary *)state
{
  GroupViewController *groupVC = [[GroupViewController alloc]initWithState:state];
  
  id myself = [super initWithRootViewController:groupVC];
  if (!myself) 
    return nil;

  return self;
}


- (GroupViewController *)groupViewController
{
  return (GroupViewController *)(super.viewControllers)[0];
}

- (void)clear
{
  if([[self.viewControllers.lastObject class]isSubclassOfClass:[EntryDetailsViewController class]])
  {
    EntryDetailsViewController *entryDetails = (EntryDetailsViewController *)self.viewControllers.lastObject;
    if(entryDetails.isEditing)
      [entryDetails onCancelEdit:self];
  }
  UIViewController *currentVC = self.viewControllers.lastObject;
  [currentVC dismissModalViewControllerAnimated:YES];
  [self popToRootViewControllerAnimated:YES];
  [self.groupViewController clear];
}

#pragma mark - View lifecycle

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  // Return YES for supported orientations
  return YES;
}

@end
