//
//  Entry.h
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 3/7/11.
//  Copyright 2011 app77. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SafeFile;

@interface Entry : NSObject

- (id) initWithEntry:(Entry *)entry file:(SafeFile *)file;
- (id) initWithFile:(SafeFile *)file;
- (NSString *) randomPassword;
- (BOOL)matchesSearchTerm:(NSString *)searchText titleOnly:(BOOL)titleOnly;
- (void) clearPwHistory;
- (void) addPasswordToHistory:(NSString *)password withPMtime:(time_t)time;
- (void) generateNewUUID;

#ifdef __cplusplus

class CItemData;
@property (nonatomic, assign, readonly) const CItemData *cItemData;
- (void)setCItemData:(const CItemData *)cItemData isConst:(BOOL)isConst;

- (id) initWithItemData:(const CItemData &)cItemData file:(SafeFile *)file;

struct PWPolicy;
- (void) getPasswordPolicy:(PWPolicy &)policy;
- (void) setPasswordPolicy:(const PWPolicy &)policy;

#endif

- (NSComparisonResult) caseInsensitiveCompare:(Entry *)aEntry;

@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *username;
@property (nonatomic, copy) NSString *password;
@property (nonatomic, copy) NSString *group;
@property (nonatomic, copy) NSString *url;
@property (nonatomic, copy) NSString *email;
@property (nonatomic, copy) NSString *notes;
@property (nonatomic, copy) NSString *pwPolicyName;
@property (nonatomic) BOOL isProtected;
@property (nonatomic, readonly) BOOL passwordPolicyNumericOnly;
@property (nonatomic, readonly) BOOL hasCustomPasswordPolicy;
@property (nonatomic, readonly) NSURL *parsedURL;
@property (nonatomic, readonly) NSData *uuid;
@property (nonatomic, readonly) NSString *details;
@property (nonatomic, readonly) SafeFile *safeFile;
@property (nonatomic) BOOL pwHistoryKeep;
@property (nonatomic) uint pwHistoryMaxEntries;
@property (nonatomic, readonly, strong) NSArray *pwHistory;
@property (nonatomic, strong) NSDate *mTime; ///< Modification time
@property (nonatomic, strong, readonly) NSDate *cTime; ///< Creation time

@end

@interface PwHistoryEntry : NSObject

@property (nonatomic, strong) NSDate *changeTimestamp;
@property (nonatomic, strong) NSString *password;

@end
