//
//  MasterPasswordViewController.h
//  pwSafe
//
//  Created by Jorge Peixoto Vasquez on 12/08/11.
//  Copyright (c) 2011 app77. All rights reserved.
//

#import <UIKit/UIKit.h>

extern NSString * const kMasterPasswordEnabledKey;
extern NSString * const kMasterPasswordSaltKey;
extern NSString * const kMasterPasswordHashKey;
extern NSString * const kMasterPasswordExpireMinutesKey;

@interface MasterPasswordViewController : UIViewController <UIPopoverControllerDelegate, UITextFieldDelegate>

typedef void (^MasterPasswordCallbackT)(MasterPasswordViewController *vc, NSString *password);

- (id)initWithTitle:(NSString *)title instructions:(NSString *)instructions accessibilityLabel:(NSString *)accessibilityLabel allowCancel:(BOOL)allowCancel callback:(MasterPasswordCallbackT)callback;
- (void)promptAgain:(NSString *)newPrompt accessibilityLabel:(NSString *)newAccessibilityLabel;
- (void)presentInViewController:(UIViewController *)viewController;
- (void)dismiss;
- (void)badPassword;

+ (BOOL)isEnabled;
+ (void)enableInViewController:(UIViewController *)viewController callback:(void (^)(BOOL ok))callback;
+ (void)disableInViewController:(UIViewController *)viewController callback:(void (^)(BOOL ok))callback;
+ (void)verifyInViewController:(UIViewController *)viewController allowCancel:(BOOL)allowCancel callback:(void (^)(BOOL ok))callback;
+ (void)changePasswordInViewController:(UIViewController *)viewController;
+ (NSData *)encryptString:(NSString *)string;
+ (NSString *)decryptString:(NSData *)encrypted;

@property (nonatomic, copy) NSString *instructions;

@end
