//
//  NSArray+Find.m
//  App77
//
//  Created by Jorge P Vasquez on 3/4/13.
//  Copyright (c) 2013 RPM. All rights reserved.
//

#import "NSArray+Find.h"

@implementation NSArray (Find)

- (NSUInteger)indexOfObjectWithProperty:(NSString *)property equalTo:(id)key
{
  if(!self.count)
    return NSNotFound;
  
  SEL sel = NSSelectorFromString(property);
  NSMethodSignature *sig = [self[0] methodSignatureForSelector:sel];
  NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:sig];
  invocation.selector = sel;
  NSAssert(sig.methodReturnLength == sizeof(void *), @"adjust accordingly");
  
  return [self indexOfObjectPassingTest:^BOOL(id obj, NSUInteger idx, BOOL *stop) {
    [invocation invokeWithTarget:obj];
    __unsafe_unretained id value = nil;
    [invocation getReturnValue:&value];
    *stop = [value isEqual:key];
    return *stop;
  }];
}

- (id)objectWithProperty:(NSString *)property equalTo:(id)key
{
  NSUInteger idx = [self indexOfObjectWithProperty:property equalTo:key];
  return idx == NSNotFound ? nil : self[idx];
}

@end
