//
//  NewEditSafeViewController.h
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 3/16/11.
//  Copyright 2011 app77. All rights reserved.
//

#import <UIKit/UIKit.h>


@interface NewEditSafeViewController : UITableViewController <UITextFieldDelegate>


@property (unsafe_unretained, nonatomic, readonly) NSString *safePath;
@property (unsafe_unretained, nonatomic, readonly) NSString *safePassword;
@property (unsafe_unretained, nonatomic, readonly) NSString *safeName;
@property (nonatomic, readonly) BOOL result;
@property (nonatomic, readonly) BOOL passwordsMatch;
@property (nonatomic, readonly) BOOL filenameAllowed;
@property (nonatomic, strong) NSArray *forbiddenNames;
@property (nonatomic, copy) NSString *dropboxDir;

/// To create a new safe

#ifdef PWSAFE_COZI
- (id) initWithTarget:(id)target selector:(SEL)selector directory:(NSString *)newSafeDir;
#else
- (id) initWithTarget:(id)target selector:(SEL)selector directory:(NSString *)newSafeDir locationName:(NSString *)locName;
#endif


/// To edit a safe
- (id) initWithTarget:(id)target selector:(SEL)selector name:(NSString *)currentName;

@end
