//
//  PasswordPolicy.h
//  pwsafemac
//
//  Created by Jorge Peixoto Vasquez on 26/04/12.
//  Copyright (c) 2012 app77. All rights reserved.
//

#import <Foundation/Foundation.h>

#ifdef __cplusplus

class PWPolicy;

#endif

@class SafeFile;
@class Entry;

@interface PasswordPolicy : NSObject <NSCopying>

- (id)initForSafe:(SafeFile *)file;
- (id)initForEntry:(Entry *)entry;
- (id)initForNamedPolicy:(NSString *)policyName inSafe:(SafeFile *)file;
- (id)initWithEmptyPolicy;
- (void)updateSafe:(SafeFile *)safe;
- (void)updateEntry:(Entry *)entry;
- (void)updateNamedPolicy:(NSString *)policyName inSafe:(SafeFile *)file;

- (BOOL)isEqualToPolicy:(PasswordPolicy *)other;

#ifdef __cplusplus
@property (nonatomic, readonly) PWPolicy &policy;
#endif

@end
