//
//  PwHistoryVC.h
//  pwSafe
//
//  Created by Jorge P. Vasquez on 04/10/12.
//
//

#import <UIKit/UIKit.h>

@class Entry;
@class PwHistoryVC;
@class SafeFile;

@protocol PwHistoryVCDelegate <NSObject>

@required
- (void)historyVC:(PwHistoryVC *)historyVC setEditing:(BOOL)editing;

@optional
- (BOOL)historyVC:(PwHistoryVC *)historyVC willSetEditing:(BOOL)editing;

@end

@interface PwHistoryVC : UITableViewController

- (id)initWithEntry:(Entry *)entry edition:(BOOL)edition;
- (id)initWithSafeFile:(SafeFile *)file;
- (void)safeWasInternallyModified;

@property (nonatomic) BOOL historyEnabled;
@property (nonatomic) uint maxEntries;
@property (nonatomic) BOOL shouldClearHistory;
@property (nonatomic) BOOL shouldUpdateAllEntries;
@property (nonatomic, unsafe_unretained) id<PwHistoryVCDelegate> delegate;
@property (nonatomic, strong) Entry *entry;

@end


