//
//  RootViewController.h
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 3/4/11.
//  Copyright 2011 app77. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "IASKAppSettingsViewController.h"

@class SafeCtx;
@class MBProgressHUD;
@class SafeFile;


@interface RootViewController : UITableViewController <UIAlertViewDelegate, UITextFieldDelegate>
{
@protected
  NSMutableArray *m_filesInDocsFolder;
  NSMutableArray *m_filesInDropboxFolder;
  NSMutableArray *m_filesInICloudFolder;
  UIActionSheet *m_currentActionSheet;
  NSURL *m_iCloudURL;
}

- (id)initWithState:(NSMutableDictionary *)state;
- (void)refresh;
- (void)loadSavedState;
- (BOOL)showWelcomeIfNeeded;
- (void)showMacAddIfNeeded;
- (void)appDidBecomeActive;
- (void)appDidBecomeActiveInternal;
- (void)appWillResignActive;

- (NSMutableArray *) safesInDirectory: (NSString *) dir;
- (void)insertSafe:(NSString *)newSafeFileName inTable:(NSMutableArray *)table section:(NSUInteger)section;
- (void)onAddComplete:(id)sender;
- (void)createNewLocalSafe;
- (NSMutableArray * __strong *) filesForSection:(NSUInteger)section;
- (void)commitDeleteForIndexPath:(NSIndexPath *)indexPath;
- (void)safeRenamedFrom:(NSString *)fileName to:(NSString *)newFileName inSection:(NSInteger)section;
- (void)moveRowsReflectingTableChangeFrom:(NSArray *)oldTable to:(NSArray *)newTable inSection:(NSInteger)section;
- (NSString *) filePath: (NSIndexPath *) indexPath;
- (void)openSafeWithUUID:(NSString *)safeUUID password:(NSString *)password animated:(BOOL)animated;
- (void)openSafeWithName:(NSString *)safeName groupName:(NSString *)groupName searching:(NSString *)searchStr animated:(BOOL)animated;

void recoverSafesInDir(NSString *dir);

- (NSString *)dirOfSection:(NSUInteger)section;

@end

static inline NSInteger RVC_SectionCount()
{
  static NSInteger count = -1;
  if(count < 0)
  {
    NSString *ver = [[UIDevice currentDevice] systemVersion];
    unichar first = [ver characterAtIndex:0];
    unichar second = [ver characterAtIndex:1];
    BOOL is6 = second == L'.' && (first == L'5' || first == L'6');
    count = is6 ? 4 : 3;
  }
  return count;
}

#define RVC_SECTION_LOCAL 0
#define RVC_SECTION_DROPBOX 1
#define RVC_SECTION_ICLOUD 2
#define RVC_SECTION_DUMMY 3
#define RVC_SECTION_COUNT RVC_SectionCount()

#define ALERTVIEW_TAG_EXECUTE_BLOCK 211
extern const void * const kAlertBlockKey;
extern const void * const kAlertTextViewAlertKey;


