//
//  SafeCtx.h
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 3/10/11.
//  Copyright 2011 app77. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface SafeCtx : NSObject <NSCoding>

@property (assign, nonatomic) int32_t keepAlivePeriod; // Minutes
@property (unsafe_unretained, readonly, nonatomic) NSString *keepAlivePeriodText;
@property (copy, nonatomic) NSString *password;
@property (unsafe_unretained, readonly, nonatomic) NSString *safeName;
@property (unsafe_unretained, readonly, nonatomic) NSString *safePath;
@property (unsafe_unretained, readonly, nonatomic) NSString *safeTempPath;
@property (unsafe_unretained, nonatomic, readonly) NSDate *sleepTimeStamp;
@property (readonly, nonatomic) BOOL expired;
@property (assign, nonatomic) BOOL opened;

@property (nonatomic, readonly) BOOL isCloud;
@property (strong, nonatomic) NSString *safeUUID;

- (id) initWithPath: (NSString *)path;
- (void)sleep;
- (void)expireNow;
- (void)updateSafePath:(NSString *)newSafePath;

#ifndef PWSAFE_COZI
- (void)decryptPassword;
#endif

#ifdef PWSAFE_WITH_DROPBOX
@property (assign, nonatomic) BOOL dropboxModified;
@property (nonatomic, readonly) int64_t dropboxRevision;
@property (nonatomic, readonly) NSString *dropboxRev;
@property (nonatomic, readonly) BOOL dropboxLastSyncExpired;
@property (strong, nonatomic, readonly) NSDate *dropboxSyncTimestamp;
@property (copy, nonatomic) NSString *dropboxPath;

- (void)syncedWithDropboxRev:(NSString *)rev;
#endif

#ifdef PWSAFE_COZI

@property (assign, nonatomic) BOOL coziModified;
@property (copy, nonatomic) NSString *coziSafeId;
@property (copy, nonatomic, readonly) NSString *coziFileName;
@property (nonatomic, copy) NSString *coziDisplayName;
@property (nonatomic) BOOL coziDeleted;
@property (nonatomic) BOOL coziRenamed;

- (void)syncedWithCoziFileName:(NSString *)coziFileName;

#endif

@end
