//
//  SafeCtxStorage.h
//  iPasswordSafe
//
//  Created by Jorge Peixoto Vasquez on 3/21/11.
//  Copyright 2011 app77. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SafeCtx;

@interface SafeCtxStorage : NSObject 

@property (nonatomic, strong, readonly) SafeCtx *openedSafeCtx;

+ (SafeCtxStorage *)sharedStorage;

- (SafeCtx *)safeCtxForPath:(NSString *)path;
- (SafeCtx *)safeCtxForUUID:(NSString *)uuid;
- (void)deleteCtxForPath:(NSString *)path;
- (void)safeMovedFromPath:(NSString *)oldPath toPath:(NSString *)newPath;
- (void)save;
- (NSArray *)allSafeCtxs;
#ifndef PWSAFE_COZI
- (void)decryptPasswordsIfNeeded;
#endif

- (SafeCtx *)objectForKeyedSubscript:(NSString *)path;

@end
