//
//  SafeFile+Print.h
//  pwSafe
//
//  Created by Jorge P. Vasquez on 25/09/12.
//
//

#import "SafeFile.h"

@class SafeFilePaperContext;

@interface SafeFile (Print)

typedef void (^SafeFilePDFCallback)(BOOL ok, NSError *error, NSString *pdfPath);

// Generates PDF
- (void)saveAsPDFToPath:(NSString *)pdfFilePath password:(NSString *)password name:(NSString *)friendlyName pageSize:(CGSize)pageSize callback:(SafeFilePDFCallback)callback;

// Low level drawing

// Coordinate system here is always the Quartz coordinate system, i.e. (0,0) on the bottom left
- (SafeFilePaperContext *)createPaperContextForPaperSize:(CGSize)paperSize name:(NSString *)friendlyName printableRect:(CGRect)printableRect;
- (NSInteger)numberOfPagesInPaperContext:(SafeFilePaperContext *)paperContext;
- (void)drawPage:(NSInteger)page fromPaperContext:(SafeFilePaperContext *)paperContext inGraphicsContext:(CGContextRef)context;


@end

#ifdef __IPHONE_OS_VERSION_MAX_ALLOWED
@interface SafeFilePageRenderer : UIPrintPageRenderer

- (id)initWithSafeFile:(SafeFile *)safeFile name:(NSString *)friendlyName;

@end

#else
@interface SafeFilePrintView : NSView

- (id)initWithSafeFile:(SafeFile *)safeFile;

@end

#endif