//
//  UIViewController+OpenSafe.h
//  pwSafe
//
//  Created by Jorge Peixoto Vasquez on 04/07/12.
//  Copyright (c) 2012 app77. All rights reserved.
//

#import <UIKit/UIKit.h>

@class SafeFile;
@class SafeCtx;

@interface UIViewController (OpenSafe)

typedef void (^OpenSafeCallback)(SafeFile *safeFile, NSError *error);

@property (nonatomic, retain) SafeCtx *currentSafeCtx;
@property (nonatomic, retain) SafeFile *currentOpenedFile;
@property (nonatomic, copy) OpenSafeCallback openSafeCallback;
@property (nonatomic, copy) NSString *initialGroup;
@property (nonatomic, copy) NSString *initialSearchTerm;

- (void)loadSavedState_OpenSafe:(NSMutableDictionary *)state;
- (void)clearState:(NSMutableDictionary *)state;
- (void)closeSafeFile:(SafeFile *)file;
- (void)openSafeForCtx:(SafeCtx *)safeCtx state:(NSMutableDictionary *)state callback:(OpenSafeCallback)callback;
- (void)openSafeAndAskForPasswordIfNeeded:(NSString *)filePath state:(NSMutableDictionary *)state;
- (void)openSafeAndAskForPasswordIfNeeded:(NSString *)filePath groupName:(NSString *)groupName searchTerm:(NSString *)search state:(NSMutableDictionary *)state;
- (void)hideHud:(id)iHud;


@end


