//
//  pwSafeTheme.h
//  pwSafe
//
//  Created by Jorge Peixoto Vasquez on 10/07/12.
//  Copyright (c) 2012 app77. All rights reserved.
//

#import <Foundation/Foundation.h>

#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C
#endif

EXTERN_C BOOL iOS6();
EXTERN_C NSString *imageName(NSString *name);

extern UIColor * const kThemeCellBgTopColor;
extern UIColor * const kThemeCellBgBottomColor;
extern UIColor * const kThemeCellUnselectedTopColor;
extern UIColor * const kThemeCellUnselectedBottomColor;

extern UIColor * const kThemeGroupedCellBgBgColor;
extern UIColor * const kThemeGroupedCellBgStrokeColor;
extern UIColor * const kThemeBackgroundPatternColor;
extern const CGFloat kThemeGroupedCellBgCornerRadius;

extern UIColor * const kNavTextColor;
extern UIColor * const kNavUnselectedTextColor;
extern UIColor * const kNavTextShadowColor;
extern const CGSize kNavShadowOffset;
extern UIColor * const kGrouppedTableViewLabelColor;

// iOS 7 and up
extern UIColor * const kThemeTintColor;
extern UIColor * const kThemeLightTintColor;

extern UIColor * const kThemeDarkBgColor;

#define kThemeBarStyle UIBarStyleBlack

@interface UIBarButtonItem (pwSafeTheme)

+ (UIBarButtonItem *)buttonWithImageNamed:(NSString *)imageName target:(id)target action:(SEL)action;

@end

@interface UITableView (pwSafeTheme)

typedef enum TableViewPosEnum
{
  TVP_LEFT,
  TVP_RIGHT,
  TVP_FORMSHEET
} TableViewPos;

- (void)themeViewDidLoadInIpadPos:(TableViewPos)pos;

- (void) addBackgroundsToGroupedCell:(UITableViewCell *)cell atIndexPath:(NSIndexPath *)indexPath;

- (void)addThemeToPlainCell:(UITableViewCell *)cell;

#ifdef __cplusplus
#define PWTHEME_CFUNC extern "C"
#else
#define PWTHEME_CFUNC 
#endif

PWTHEME_CFUNC void pwSafeThemeSetup(UIWindow *window);

PWTHEME_CFUNC UIView *themeGroupViewDisabledImage(CGRect frame, BOOL landscape);

@end

@interface UIViewController (pwSafeTheme)

- (void)themeViewWithNavPromptDidLoad;

@end

@interface UITableViewController (pwSafeTheme)

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section;
- (UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section;

@end

