/*
* Copyright (c) 2003-2013 Rony Shapiro <ronys@users.sourceforge.net>.
* All rights reserved. Use of the code is allowed under the
* Artistic License 2.0 terms, as specified in the LICENSE file
* distributed with this code, or available from
* http://www.opensource.org/licenses/artistic-license-2.0.php
*/

/**
 * \file MacOS-specific implementation of some wide-string related functionality
 */

#include <wchar.h>
#include "pws_str.h"
#include "../utf8conv.h"
#import "NSStringUtils.h"

int pws_os::wctoi(const wchar_t *s)
{
  return int(wcstol(s, NULL, 10));
}

double pws_os::wctof(const wchar_t *s)
{
  return double(wcstold(s, NULL));
}

/*
 * had to define this for gcc 4.0 on osx.
 * http://trac.wildfiregames.com/ticket/414
 */
int pws_os::wcscasecmp(const wchar_t* s1, const wchar_t* s2)
{
  size_t s1Len = wcslen(s1);
  size_t s2Len = wcslen(s2);
  NSString *ns1 = [[NSString alloc]initWithBytesNoCopy:const_cast<wchar_t *>(s1) length:s1Len encoding:kEncoding_wchar_t freeWhenDone:NO];
  NSString *ns2 = [[NSString alloc]initWithBytesNoCopy:const_cast<wchar_t *>(s2) length:s2Len encoding:kEncoding_wchar_t freeWhenDone:NO];
  
  NSComparisonResult r = [ns1 caseInsensitiveCompare:ns2];
  return r;
}


